diff --git a/web/test/integration/daemon_maintenance_test.rb b/web/test/integration/daemon_maintenance_test.rb
new file mode 100644
index 00000000..4a07dab7
--- /dev/null
+++ b/web/test/integration/daemon_maintenance_test.rb
@@ -0,0 +1,12 @@
+require "test_helper"
+
+class DaemonMaintenanceTest < ActionDispatch::IntegrationTest
+  test "rejects arbitrary service command text before creating an operation" do
+    sign_in!
+
+    post daemon_maintenance_path, params: { action: "restart; rm -rf /" }
+
+    assert_response :unprocessable_entity
+    assert_equal "unsupported maintenance action", JSON.parse(response.body).fetch("error")
+  end
+end
diff --git a/web/test/integration/local_loopback_auth_test.rb b/web/test/integration/local_loopback_auth_test.rb
new file mode 100644
index 00000000..247d8487
--- /dev/null
+++ b/web/test/integration/local_loopback_auth_test.rb
@@ -0,0 +1,28 @@
+require "test_helper"
+
+class LocalLoopbackAuthTest < ActionDispatch::IntegrationTest
+  around do |test|
+    previous = ENV["HIVE_WEB_LOCAL_LOOPBACK"]
+    ENV["HIVE_WEB_LOCAL_LOOPBACK"] = "1"
+    test.call
+  ensure
+    previous.nil? ? ENV.delete("HIVE_WEB_LOCAL_LOOPBACK") : ENV["HIVE_WEB_LOCAL_LOOPBACK"] = previous
+  end
+
+  test "loopback peer with a loopback Host bypasses GitHub login" do
+    host! "localhost"
+    get "/", headers: { "REMOTE_ADDR" => "127.0.0.1" }
+
+    assert_response :success
+  end
+
+  test "remote peer and hostile Host never gain local trust" do
+    host! "localhost"
+    get "/", headers: { "REMOTE_ADDR" => "10.0.0.9", "HTTP_X_FORWARDED_FOR" => "127.0.0.1" }
+    assert_redirected_to login_path
+
+    host! "attacker.test"
+    get "/", headers: { "REMOTE_ADDR" => "127.0.0.1" }
+    assert_redirected_to login_path
+  end
+end
